#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os
dir_path = os.path.dirname(os.path.realpath(__file__))

ALGO_DICT = {"na_lcms": 'convert_file_LCMS',
             "na_msms": 'convert_file_MSMS',
             "quant_lcms": 'convert_lcms_quant',
             "quant_msms": 'convert_msms_quant',
             "maven_qc": 'convert_maven_to_sample_qc',
             "maven_pvd": 'convert_maven_to_unlabelled_pvd',
             "isocorrect_quant_lcms":'convert_isocorrect_to_quant_lcms',
             "isocorrect_qc_lcms":'convert_isocorrect_to_quickcheck_lcms',
             "quant_qc_lcms":'convert_quantfit_to_quickcheck_lcms',
             "quant_metscape_lcms":'convert_quantfit_to_metscape_lcms'
             }

ACTION = 'action'
ACTION_MSG = 'Action Taken : Missing value of columns replaced with 0'
ADDUCTNAME = 'adductName'
COLUMN_NAME = 'column_name'
COLUMN_LIST = 'column_list'
COMPONENT_NAME = 'Component Name'
COMPOUND = 'compound'
COMPOUNDID_COLUMN = "compoundId"
COMP_HMDB_FILE = os.path.join(dir_path,'./data/compound_hmdb_list.csv')
CSV_FILE = '.csv'
LABEL_REGEX_CHECK = "(((([\w ])+(-label-)([\w ])*[0-9]+(-[0-9])*))|(\w*\sPARENT))"

DICT_READ_MAVEN_FILE = {
        'file_path': None,
        'required_columns': [],
        'warnings': {
            'missing': 'FILL_NA',
            'duplicate': 'DROP',
        },
        'functions': {
            'numerical': {'column_list': [],
                          'negative state': 'negative',
                          'invalid state': 'invalid num'}
        }
    }

EXCEL_FILES = ['.xls', '.xlsx']
ERRORS = 'errors'
FILE_PATH = 'file_path'
FORMULA = 'Formula'
FORMULA_TYPES = ['Formula','formula']
FUNCTIONS = 'functions'
HMDB = "HMDB"
HMDBID_COLUMN = 'hmdb_id'
ID = 'id'
ISOTOPIC_TRACER = 'Isotopic Tracer'
KEGG_ID = "kegg_id"
MASS_INFO = 'Mass Info'
MESSAGE = 'message'
MISSING_COMPONENTS = 'missing_components'
MS = 'ms'
MSMS = 'msms'
ISOCORRECT = 'isocorrect'
NAME = 'name'
NUMERICAL = 'numerical'
PARENT_FORMULA = 'Parent Formula'
PEAK_AREA_CORRECTED = 'peakAreaCorrected'
QUANTFIT = 'quantfit'

MAVEN_REQUIRED_COL_LIST_OLD = ['compound', 'note', 'label', 'metaGroupId', 'groupId',
                     'maxQuality', 'compoundId', 'expectedRtDiff',
                     'ppmDiff', 'medRt', 'parent', 'goodPeakCount',
                     'medMz']

MAVEN_REQUIRED_COL_LIST = ['compound', 'note', 'label', 'metaGroupId', 'groupId',
                     'maxQuality', 'compoundId', 'expectedRtDiff',
                     'ppmDiff', 'medRt', 'parent', 'goodPeakCount',
                     'medMz', 'formula']

MAV_REQUIRED_COL_LIST = ['compound', 'isotopeLabel', 'label', 'metaGroupId', 'groupId',
                     'maxQuality', 'compoundId', 'expectedRtDiff',
                     'ppmDiff', 'medRt', 'parent', 'goodPeakCount',
                     'medMz', 'formula', 'adductName']

REQUIRED_COL_LIST_MSMS = ['groupId', 'compound', 'compoundId', 'sample',
                          'peakMz', 'medianMz', 'baseMz', 'rt', 'rtmin', 'rtmax',
                          'quality', 'peakIntensity', 'peakArea', 'peakAreaTop',
                          'peakAreaCorrected', 'noNoiseObs', 'signalBaseLineRatio',
                          'fromBlankSample']

ISOCORRECT_REQUIRED_COL_LIST =['Formula','Fractional Enrichment',
                            'Fractional Enrichment with zero','Label','Name','Sample',
                            'Truth Value_x','Intensity','Unlabeled Fragment',
                            'Indistinguishale_isotope','NA Corrected','NA Corrected with zero',
                            'Pool_total','Truth Value_y']

QUANT_REQUIRED_COL_LIST = ['Intensity', 'Point Type','Cohort Name','Sample Name',
                           'Point Name','Metabolite Name', 'Concentration','Normalized Conc', 'adductName']

ROW_NUMBER = "Row Number"
ROW_NUMBER_COLUMN = 'row_number'
SMALL_L_LABEL_COLUMN = 'label'
SOURCE_FILE_PATH = os.path.join(dir_path,'./data/metadata_mq_with_method_all.xlsx')
SOURCE_FILE_PATH_TEST = os.path.join(dir_path,'./data/new_metadata.xlsx')
SOURCE_FILE_PVD_PATH = os.path.join(dir_path,'./data/kegg_hmdb.csv')
STATE = 'state'
TXT_FILE = '.txt'
UNLABELED_FRAGMENT = 'Unlabeled Fragment'
WARNINGS = 'warnings'

# <=================================================================================================>

MQ_COHORT_NAME = 'Sample Name'
MQ_FRAGMENT = 'Component Name'
PARENT = 'Unlabeled Fragment'
MQ_SAMPLE_NAME = 'Original Filename'
SAMPLE_NAME = "sample_name"
COHORT_NAME = "cohort_name"
MQ_INTENSITY = 'Area'
MQ_REPLICATES = 'Replicates'
MQ_CONCENTRATION = 'Concentration'
MQ_INDEX='Index'
UNIT = 'Unit'
ERRORS = 'errors'
WARNINGS = 'warnings'
ACTION = 'action'
MESSAGE = 'message'
UNT = "unit"
INTERCEPT = 'intercept'

METADATA_MQ_FILE = "metadata_mq"
METADATA_STD_SAMPLE_FILE = "metadata_std_sample"
MQ_FILES = "mq_files"

METABOLITE_INFO = "metabolite_info"
WARNING = "warning"

BIOSAMPLE_DATA = "biosample_data"
MERGED_STD = "merged_std"


AVGAREA='averageArea'
AVG_AREA='Average_Area'
CONC='concentration'
WEIGHT='weightString'
NO_WEIGHT = '1.0'
STD_DEV='Std_dev'
STDDEV = "stdDeviation"
INTENSITY_PRES=6
BIOSAMPLE_CONC='Concentration'
NORMALIZE_CONC = "normalize_conc"
NORMALIZED_CONC = "normalized_conc"
AREA_KEY = "areakey"
AREA_VALUE = "areavalue"
STD_DATA = "standard_data"
NAME = "name"
METABOLITE_NAME = "metabolite_name"
FRAGMENT_NAME = "fragment_name"
POINT_NAME = "point_name"
INTENSITY = "intensity"
MISSING_COMPONENTS = "missing_components"
COMPONENT_NAME = 'Component Name'
QUANT_LCMS = 'quant_lcms'
QUANT_MSMS = 'quant_msms'
MS = 'ms'
ISOCORRECT = 'isocorrect'
ISOCORRECT_QUANT_LCMS = 'isocorrect_quant_lcms'

NUMBER_OF_POINTS = 200
INITIAL_POINT = 0


#config
PRESICION=6

PRESICION_TABLE = 2

LOGBASE = 10

DICT_READ_MULTIQUANT = {
    'file_path': '',
    'required_columns': [MQ_SAMPLE_NAME, MQ_COHORT_NAME, MQ_FRAGMENT,
                            MQ_INTENSITY],
    'warnings': {
        'missing': 'FILL_NA',
        'duplicate': 'DROP',
    },
    'functions': {
        'missing_data': {
                        'state': 'missing'
                        }
    }
}

DICT_READ_MULTIQUANT_METADATA = {
    'file_path': '',
    'required_columns': [COMPONENT_NAME, PARENT],
    'warnings': {
        'missing': 'FILL_NA',
        'duplicate': 'DROP',
    },
    'functions': {
        'missing_data': {
                        'state': 'missing'
                        }
    }
}

DICT_READ_STD_SAMPLE_METADATA = {
    'file_path': '',
    'required_columns': [MQ_COHORT_NAME, MQ_CONCENTRATION, PARENT, MQ_SAMPLE_NAME],
    'warnings': {
        'missing': 'FILL_NA',
        'duplicate': 'DROP'
    },
    'functions': {
        'numerical': {'column_list': [MQ_CONCENTRATION],
                        'negative state': 'negative intensity',
                        'invalid state': 'invalid num'},
        'missing_data': {
            'state': 'missing'
        }
    }
}

CORNA_LCMS_CHECK = {'pattern_match': {'column_name': 'isotopeLabel',
                                  'regex_pattern': LABEL_REGEX_CHECK,
                                  'state': 'Invalid IsotopeLabel'}}
